﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Infragistics.Web.UI.ListControls;

namespace WebDataGrid
{
    public partial class Page1 : System.Web.UI.Page
    {

       
      
        protected DataTable GetGrid1Data()
        {
            if (Session["dt"] == null)
            {
                DataTable dt = new DataTable();
                dt.Columns.Add("ID");
                dt.Columns.Add("Department ID");
                dt.Columns.Add("Department Name");

                dt.Rows.Add("1", "D1", "Department 1");
                dt.Rows.Add("2", "D2", "Department 2");
                dt.Rows.Add("3", "D3", "Department 3");
                dt.Rows.Add("4", "D4", "Department 4");
                dt.Rows.Add("5", "D5", "Department 5");
                dt.Rows.Add("6", "D6", "Department 6");
                dt.Rows.Add("7", "D7", "Department 7");

                Session["dt"] = dt;
                return dt;
            }
            else
            {
                DataTable dt = (DataTable)Session["dt"];
                return dt;
            }
        }
        protected DataTable GetGrid2Data()
        {
            if (Session["dt1"] == null)
            {
                DataTable dt = new DataTable();
                dt.Columns.Add("ID");
                dt.Columns.Add("Emp Name");
                dt.Columns.Add("Emp Type");

                dt.Rows.Add("1", "E1", "Employee 1");
                dt.Rows.Add("2", "E2", "Employee 2");
                dt.Rows.Add("3", "E3", "Employee 3");
                dt.Rows.Add("4", "E4", "Employee 4");
                dt.Rows.Add("5", "E5", "Employee 5");
                dt.Rows.Add("6", "E6", "Employee 6");
                dt.Rows.Add("7", "E7", "Employee 7");
                Session["dt1"] = dt;
                return dt;
            }
            else
            {
                DataTable dt = (DataTable)Session["dt1"];
                return dt;
            }
        }

        public DataTable GetDepartment()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("Department Name");
            dt.Columns.Add("Owner");

            dt.Rows.Add("1", "Department 1", "ABCD1");
            dt.Rows.Add("2", "Department 2", "ABCD2");
            dt.Rows.Add("3", "Department 3", "ABCD3");
            dt.Rows.Add("4", "Department 4", "ABCD4");
            dt.Rows.Add("5", "Department 5", "ABCD5");
            dt.Rows.Add("6", "Department 6", "ABCD6");
            dt.Rows.Add("7", "Department 7", "ABCD7");
            return dt;
        }
        protected DataTable GetEmployee()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("Emp Name");

            dt.Rows.Add("1", "Employee 1");
            dt.Rows.Add("2", "Employee 2");
            dt.Rows.Add("3", "Employee 3");
            dt.Rows.Add("4", "Employee 4");
            dt.Rows.Add("5", "Employee 5");
            dt.Rows.Add("6", "Employee 6");
            dt.Rows.Add("7", "Employee 7");

            return dt;
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                this.dgKeyWords.Behaviors.CreateBehavior<EditingCore>();
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CreateBehavior<RowDeleting>();
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CreateBehavior<RowAdding>();

                this.dgKeyWords.Behaviors.EditingCore.BatchUpdating = true;
                this.dgKeyWords.Behaviors.EditingCore.AutoCRUD = false;

                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.Enabled = true;
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.RowAdding.Enabled = true;
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.EnableF2 = true;
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = EditMouseClickAction.Single;
            }


         

        }

 
        protected void ddlList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ddlList.SelectedValue.Equals("1"))
            {
                BindDataGrid("1");
            }
            else if (ddlList.SelectedValue.Equals("2"))
            {
                BindDataGrid("2");
            }

            SetGridBehaviour();

        }


        protected void BindDataGrid(string sType)
        {
            DataTable dtSourc = new DataTable();
            if (sType.Equals("1"))
                dtSourc = GetGrid1Data();
            else
                dtSourc = GetGrid2Data();

            if (dtSourc.Columns.Contains("DELETE") == false)
            {

                DataColumn dcDELETE = new DataColumn("DELETE", System.Type.GetType("System.Boolean"));
                dtSourc.Columns.Add(dcDELETE);
            }
            dgKeyWords.Columns.Clear();

            dgKeyWords.DataSource = dtSourc;
            dgKeyWords.DataBind();

        }

        protected void SetGridBehaviour()
        {

            EditingColumnSetting settingIDColumn = new EditingColumnSetting();
            settingIDColumn.ColumnKey = "ID";
            settingIDColumn.ReadOnly = true;
            this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(settingIDColumn);



            if (ddlList.SelectedValue.Equals("1"))
            {
                DropDownProvider provider = new DropDownProvider();
                provider.ID = "ddlDepartment";
                provider.EditorControl.DropDownContainerWidth = 150;
                dgKeyWords.EditorProviders.Add(provider);

                ((DropDownProvider)dgKeyWords.EditorProviders["ddlDepartment"]).EditorControl.DataSource = GetDepartment();
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlDepartment"]).EditorControl.TextField = "Department Name";
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlDepartment"]).EditorControl.ValueField = "ID";
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlDepartment"]).EditorControl.DataBind();
                
               


                EditingColumnSetting settingColDepartment = new EditingColumnSetting();
                settingColDepartment.ColumnKey = "Department Name";
                settingColDepartment.EditorID = "ddlDepartment";
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(settingColDepartment);

                RowAddingColumnSetting settingAddDepartment = new RowAddingColumnSetting();
                settingAddDepartment.ColumnKey = "Department Name";
                settingAddDepartment.EditorID = "ddlDepartment";
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(settingAddDepartment);




            }
            else if (ddlList.SelectedValue.Equals("2"))
            {
                DropDownProvider provider = new DropDownProvider();
                provider.ID = "ddlEmployee";
                provider.EditorControl.DropDownContainerWidth = 150;
                dgKeyWords.EditorProviders.Add(provider);

                ((DropDownProvider)dgKeyWords.EditorProviders["ddlEmployee"]).EditorControl.DataSource = GetEmployee();
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlEmployee"]).EditorControl.TextField = "Emp Name";
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlEmployee"]).EditorControl.ValueField = "ID";
                ((DropDownProvider)dgKeyWords.EditorProviders["ddlEmployee"]).EditorControl.DataBind();

                EditingColumnSetting settingColEmployee = new EditingColumnSetting();
                settingColEmployee.ColumnKey = "Emp Name";
                settingColEmployee.EditorID = "ddlEmployee";
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(settingColEmployee);

                RowAddingColumnSetting settingAddEmployee = new RowAddingColumnSetting();
                settingAddEmployee.ColumnKey = "Department Name";
                settingAddEmployee.EditorID = "ddlDepartment";
                this.dgKeyWords.Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(settingAddEmployee);



            }

        }




        protected void dgKeyWords_InitializeRow(object sender, RowEventArgs e)
        {
            if (e.Row.Items.FindItemByKey("ID") != null)
            {
                e.Row.Items.FindItemByKey("ID").Column.Hidden = true;
            }

            if (e.Row.Items.FindItemByKey("DELETE") != null)
            {
                e.Row.Items.FindItemByKey("DELETE").Column.Width = Unit.Pixel(70);
            }
        }

        protected void btnSave_Click(object sender, EventArgs e)
        {

        }



        protected void dgKeyWords_RowsDeleting(object sender, RowDeletingEventArgs e)
        {

        }

        protected void dgKeyWords_RowAdding(object sender, RowAddingEventArgs e)
        {
            DataTable dt = new DataTable();
            if (ddlList.SelectedValue.Equals("1"))
                dt = GetGrid1Data();
            else
                dt = GetGrid2Data();

            Int32 MaxID = Convert.ToInt32(dt.Compute("max(ID)", string.Empty));

            DataRow dr = dt.NewRow();
            dr["ID"] = MaxID + 1;

            if (ddlList.SelectedValue.Equals("1"))
            {
                dr["Department ID"] = e.Values["Department ID"];
                dr["Department Name"] = e.Values["Department Name"];
            }
            else
            {
                dr["Emp Name"] = e.Values["Emp Name"];
                dr["Emp Type"] = e.Values["Emp Type"];
            }
            if (e.Values["DELETE"] != null)
            {
                dr["DELETE"] = e.Values["DELETE"];
            }

            dt.Rows.Add(dr);

            if (ddlList.SelectedValue.Equals("1"))
            {
                Session["dt"] = dt;
            }
            else
            {
                Session["dt1"] = dt;
            }
        }

        protected void dgKeyWords_RowUpdating(object sender, RowUpdatingEventArgs e)
        {
            DataTable dt = new DataTable();
            if (ddlList.SelectedValue.Equals("1"))
                dt = GetGrid1Data();
            else
                dt = GetGrid2Data();

            DataRow dr = dt.Select("ID=" + e.Values["ID"]).FirstOrDefault();
            if (dr != null)
            {
                dr.BeginEdit();
                if (ddlList.SelectedValue.Equals("1"))
                {
                    dr["Department ID"] = e.Values["Department ID"];
                    dr["Department Name"] = e.Values["Department Name"];

                }
                else
                {
                    dr["Emp Name"] = e.Values["Emp Name"];
                    dr["Emp Type"] = e.Values["Emp Type"];
                }

                if (e.Values["DELETE"] != null)
                {
                    dr["DELETE"] = e.Values["DELETE"];
                }
                dr.AcceptChanges();
            }
            if (ddlList.SelectedValue.Equals("1"))
            {
                Session["dt"] = dt;
            }
            else
            {
                Session["dt1"] = dt;
            }


        }





    }

}